﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};const Maths = {
  lerp(a, b, n) {
    return n * (a - b) + b;
  }
};

class WEBGL {
  constructor(canvas, planeElement) {
    this.canvas = canvas;
    this.webGLCurtain = new Curtains("canvas");
    this.planeElement = planeElement;
    this.mouse = {
      x: 0,
      y: 0
    };
    this.params = {
      vertexShader: document.getElementById("vs").textContent, // our vertex shader ID
      fragmentShader: document.getElementById("fs").textContent, // our framgent shader ID
      widthSegments: 40,
      heightSegments: 40, // we now have 40*40*6 = 9600 vertices !
      uniforms: {
        time: {
          name: "uTime", // uniform name that will be passed to our shaders
          type: "1f", // this means our uniform is a float
          value: 0
        },
        mousepos: {
          name: "uMouse",
          type: "2f",
          value: [0, 0]
        },
        resolution: {
          name: "uReso",
          type: "2f",
          value: [innerWidth, innerHeight]
        }
      }
    };

    this.onMouseMove = this.onMouseMove.bind(this);
  }

  initPlane() {
    // create our plane mesh
    this.plane = this.webGLCurtain.addPlane(this.planeElement, this.params);

    // use the onRender method of our plane fired at each requestAnimationFrame call

    if (this.plane) {
      this.plane.onReady(() => {
        this.update();
        this.initEvent();
      });
    }
  }

  update() {
    this.plane.onRender(() => {
      this.plane.uniforms.time.value += 0.01; // update our time uniform value

      this.plane.uniforms.resolution.value = [innerWidth, innerHeight];

      this.plane.uniforms.mousepos.value[0] = Maths.lerp(
        this.mouse.x,
        this.plane.uniforms.mousepos.value[0],
        0.1
      );
      this.plane.uniforms.mousepos.value[1] = Maths.lerp(
        this.mouse.y,
        this.plane.uniforms.mousepos.value[1],
        0.1
      );
      
      console.log(this.plane.uniforms.mousepos.value)
    });
  }

  onMouseMove({ clientX, clientY }) {
    //this.mouse = this.plane.mouseToPlaneCoords(clientX, clientY);
    this.mouse.x = clientX / innerWidth
    this.mouse.y = (innerHeight - clientY) / innerHeight
  }

  initEvent() {
    this.canvas.addEventListener("mousemove", this.onMouseMove);
  }
}

const webgl = new WEBGL(
  document.getElementById("canvas"),
  document.getElementsByClassName("plane")[0]
);

webgl.initPlane();;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};